#ifndef RIGIDSTRUT_H
#define RIGIDSTRUT_H

#include "Constraint.h"

namespace Penguin
{
	/*! \brief A Rigid Strut between two particles.
	*
	* Refer to the Constraint document for more details.
	* Note, this constraint requires that the original positions and velocities of
	* the particles are <b>valid<b>.
	*/
	
	
	class RigidStrut: public Constraint
	{
		Particle* m_One;
		Particle* m_Two;	
		
		double m_K; //spring constant
		double m_C; //damping constant
		
		double m_W;
		double m_SquareRootW; 
		double m_L2; //strut length^2
	
		public:
		
		RigidStrut(Particle* one, Particle* two, double k=1, double c=0.1);		
		virtual void Apply();
		
		Particle* GetOne(){return m_One;}
		Particle* GetTwo(){return m_Two;}
	};
}

#endif
