/* A simple test application class.
 * Subclass to get required functionality.
 * BP - 06.08.04
 */

#include "GL/glut.h"
#include "testbed.h"
#include "PSystem.h"


#ifndef TESTBED3D_H
#define TESTBED3D_H

using namespace Penguin;

/*! \brief Provides some functionality for working in 3d space.
 *
 * "At last!", I hear my teammates cry. :|
 */ 
class TestBed3d: public TestBed
{
	protected:
		
	Vector3 m_Camera;	
	Vector3 m_LookAt;
		
	public:
	
	TestBed3d(int argc, char** argv);
	TestBed3d(int argc, char** argv,int w, int h);		
	virtual ~TestBed3d();
	virtual void GLSetup();
		
	void SetCamera(const Vector3& cam){m_Camera = cam;}
	void SetLookAt(const Vector3& lookat){m_LookAt = lookat;}	
	void Set3dViewport(double aspect);
	virtual void Reshape(int w, int h);
	virtual void Display(void);	
	void RenderGuides();
	
	void EnableLighting();
	
	virtual void KeyListener(unsigned char key, int x, int y)
	{
		TestBed::KeyListener(key,x,y);
	}
	
	/*! Rotates the camera around the Lookat Position. */
	void RotateAroundY(double angle);
	
	/*! Zoom in by some amount. */
	void Zoom(double amount);
	
};

#endif
