#ifndef MPWORLD_H
#define MPWORLD_H

#include "World.h"

namespace Penguin
{
	/*! \brief A World is a collection of interacting particles. 
	 *
	 * This world implements the MidPoint method of integration.
	*/

	class MPWorld: public World
	{
		protected:		
		/* Used in the integration technique*/
		std::vector<Vector3> m_OldPositions;
		std::vector<Vector3> m_OldVelocities;
		
		//Applies the initial impulse value then decreases the impulse force by half */
		void ApplyInitialImpulses(double dt); 
		
		public:	
		
		MPWorld(double grav=0, double res=0.01):World(grav,res){}
		
		/*! Simulate this World by some timestep dt. */		
		virtual void Simulate(double dt);
	};
}

#endif
